package cn.com.qmth.examcloud.commons.helpers;

import java.io.Serializable;

import org.apache.commons.lang3.StringUtils;

/**
 * 动态枚举
 *
 * @author WANGWEI
 * @date 2018年8月23日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public final class DynamicEnum implements Serializable {

	private static final long serialVersionUID = -694709140246715214L;

	/**
	 * ID
	 */
	private Long id;

	/**
	 * name
	 */
	private String name;

	/**
	 * 描述
	 */
	private String desc;

	/**
	 * 值匹配正则表达式
	 */
	private String pattern;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDesc() {
		return desc;
	}

	public void setDesc(String desc) {
		this.desc = desc;
	}

	public String getPattern() {
		return pattern;
	}

	public void setPattern(String pattern) {
		this.pattern = pattern;
	}

	/**
	 * 是否合法
	 *
	 * @author WANGWEI
	 * @param value
	 * @return
	 */
	public Boolean isLegal(String value) {
		if (StringUtils.isNotBlank(value) && StringUtils.isNotBlank(pattern)) {
			return value.matches(pattern);
		}
		return true;
	}

}
