package cn.com.qmth.examcloud.commons.util;

import java.security.NoSuchAlgorithmException;

import javax.net.ssl.SSLContext;

import org.apache.http.config.Registry;
import org.apache.http.config.RegistryBuilder;
import org.apache.http.conn.socket.ConnectionSocketFactory;
import org.apache.http.conn.socket.LayeredConnectionSocketFactory;
import org.apache.http.conn.socket.PlainConnectionSocketFactory;
import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.impl.conn.PoolingHttpClientConnectionManager;

/**
 * 类注释
 *
 * @author WANGWEI
 */
public class HttpClientPool
{

	private static PoolingHttpClientConnectionManager cm = null;

	static
	{
		LayeredConnectionSocketFactory sslsf = null;
		try
		{
			sslsf = new SSLConnectionSocketFactory(SSLContext.getDefault());
		}
		catch (NoSuchAlgorithmException e)
		{
			e.printStackTrace();
		}

		Registry<ConnectionSocketFactory> socketFactoryRegistry = RegistryBuilder
				.<ConnectionSocketFactory> create().register("https", sslsf)
				.register("http", new PlainConnectionSocketFactory()).build();
		cm = new PoolingHttpClientConnectionManager(socketFactoryRegistry);
		cm.setMaxTotal(200);
		cm.setDefaultMaxPerRoute(20);
	}

	/**
	 * get http client.
	 *
	 * @author WANGWEI
	 * @return
	 */
	public static CloseableHttpClient getHttpClient()
	{
		CloseableHttpClient httpClient = HttpClients.custom().setConnectionManager(cm).build();
		return httpClient;
	}

}